import 'package:ink_runtime/ink.dart';
import 'package:test/test.dart';

import '../base_ink_tests.dart';
import 'inkfiles/compiled/callstack/call_stack_evaluation.ink.json.dart'
    as call_stack_evaluation;
import 'inkfiles/compiled/callstack/clean_callstack_reset_on_path_choice.ink.json.dart'
    as clean_callstack_reset_on_path_choice;

class CallstackSpec extends BaseInkTests {
  CallstackSpec(Future<Story> Function(String) load,
      {required TestFunction test, required GroupFunction group})
      : super(
          spec: 'Callstack',
          createStory: load,
          groupFunction: group,
          testFunction: test,
        );

  @override
  void tests() {
    it('tests call stack evaluation', () async {
      var story = await createStory(call_stack_evaluation.jsonString);
      expect(story.Continue(), '8\n');
    });

    it('tests clean callstack reset on path choice', () async {
      var story =
          await createStory(clean_callstack_reset_on_path_choice.jsonString);

      expect(story.Continue(), 'The first line.\n');

      story.ChoosePathString('SomewhereElse');

      expect(story.ContinueMaximally(), 'somewhere else\n');
    });
  }
}
