import 'dart:convert';

import 'package:ink_runtime/ink.dart';
import '../../base_ink_tests.dart';
import 'package:test/test.dart';

import '../inkfiles/compiled/inkjs/tests.ink.json.dart' as $tests;

class DivertSpec extends BaseInkTests {
  DivertSpec(Future<Story> Function(String) load,
      {required TestFunction test, required GroupFunction group})
      : super(
          spec: 'Divert',
          createStory: load,
          groupFunction: group,
          testFunction: test,
        );

  late Story story;

  @override
  void tests() {
    setUp(() async {
      story = await createStory(jsonEncode($tests.json));
    });
    it('should divert to a knot', () {
      story.ChoosePathString('divert.divert_knot');

      expect(story.Continue(), 'Diverted to a knot\n');
    });

    it('should divert to a stitch', () {
      story.ChoosePathString('divert.divert_stitch');

      expect(story.Continue(), 'Diverted to a stitch\n');
    });

    it('should divert to an internal stitch', () {
      story.ChoosePathString('divert.internal_stitch');

      expect(story.Continue(), 'Diverted to internal stitch\n');
    });

    it('should divert with a variable', () {
      story.ChoosePathString('divert.divert_var');

      expect(story.Continue(), 'Diverted with a variable\n');
    });
  }
}
