import 'dart:convert';

import 'package:ink_runtime/ink.dart';
import '../../base_ink_tests.dart';
import 'package:test/test.dart';

import '../inkfiles/compiled/inkjs/tests.ink.json.dart' as $tests;

class GlueSpec extends BaseInkTests {
  GlueSpec(Future<Story> Function(String) load,
      {required TestFunction test, required GroupFunction group})
      : super(
          spec: 'Glue',
          createStory: load,
          groupFunction: group,
          testFunction: test,
        );

  late Story story;

  @override
  void tests() {
    setUp(() async {
      story = await createStory(jsonEncode($tests.json));
    });
    it('should glue lines together', () {
      story.ChoosePathString('glue.simple');

      expect(story.Continue(), 'Simple glue\n');
    });

    it('should glue diverts together', () {
      story.ChoosePathString('glue.diverted_glue');

      expect(story.Continue(), 'More glue\n');
    });
  }
}
