import 'dart:convert';

import 'package:ink_runtime/ink.dart';
import 'package:meta/meta.dart';
import 'package:test/test.dart';

import '../base_ink_tests.dart';
import 'inkfiles/compiled/multiflow/multi_flow_basics.ink.json.dart'
    as multi_flow_basics;

class MultiflowSpec extends BaseInkTests {
  MultiflowSpec(Future<Story> Function(String) load,
      {required TestFunction test, required GroupFunction group})
      : super(
          spec: 'Multiflow',
          createStory: load,
          groupFunction: group,
          testFunction: test,
        );

  @override
  @isTestGroup
  void tests() {
    testFunction('tests external bindings', () async {
      var story = await createStory(jsonEncode(multi_flow_basics.json));

      story.SwitchFlow('First');
      story.ChoosePathString('knot1');
      expect(story.Continue(), 'knot 1 line 1\n');

      story.SwitchFlow('Second');
      story.ChoosePathString('knot2');
      expect(story.Continue(), 'knot 2 line 1\n');

      story.SwitchFlow('First');
      expect(story.Continue(), 'knot 1 line 2\n');

      story.SwitchFlow('Second');
      expect(story.Continue(), 'knot 2 line 2\n');
    });
  }
}
