import 'package:ink_runtime/ink.dart';

import 'base_ink_tests.dart';
import 'ink/bindings_spec.dart';
import 'ink/builtins_spec.dart';
import 'ink/choices_spec.dart';
import 'ink/conditions_spec.dart';
import 'ink/diverts_spec.dart';
import 'ink/evaluation_spec.dart';
import 'ink/inkjs/choices_spec.dart';
import 'ink/inkjs/content_spec.dart';
import 'ink/inkjs/divert_spec.dart';
import 'ink/inkjs/game_queries_spec.dart';
import 'ink/inkjs/glue_spec.dart';
import 'ink/inkjs/integration_spec.dart';
import 'ink/inkjs/lists_spec.dart';
import 'ink/inkjs/simple_list_spec.dart';
import 'ink/inkjs/tags_spec.dart';
import 'ink/multiflow_spec.dart';
import 'ink/tags_spec.dart';

abstract class RuntimeTests {
  static void runAll(Future<Story> Function(String) load, TestFunction test,
      GroupFunction group) {
    BindingsSpec(load, test: test, group: group).run();
    ChoicesSpec(load, test: test, group: group).run();
    TagsSpec(load, test: test, group: group).run();
    BuiltinsSpec(load, test: test, group: group).run();
    ConditionsSpec(load, test: test, group: group).run();
    DivertsSpec(load, test: test, group: group).run();
    EvaluationSpec(load, test: test, group: group).run();
    // inkjs
    InkjsChoicesSpec(load, test: test, group: group).run();
    ContentSpec(load, test: test, group: group).run();
    DivertSpec(load, test: test, group: group).run();
    GameQueriesSpec(load, test: test, group: group).run();
    GlueSpec(load, test: test, group: group).run();
    ListsSpec(load, test: test, group: group).run();
    SimpleListsSpec(load, test: test, group: group).run();
    InkjsTagsSpec(load, test: test, group: group).run();
    MultiflowSpec(load, test: test, group: group).run();
    InkjsIntegrationSpec(load, test: test, group: group).run();
  }
}
